$sheader= "SUPERBOARD DB File Ver 1.0\x1a";
$slen= length($sheader);
$maxDB= 500;

sub sb_c2n { my ($chr)= @_;
	$a1= ord(substr($chr,0,1));
	$a2= ord(substr($chr,1,1));

	return ($a2*256+$a1);
}

sub sb_n2c { my ($nums)= @_;

	return substr((pack "I", $nums),0,2);
}

sub sb_offsetDB {	my ($tail)= @_;
	my ($i, $sizeo)= 0;
	
	unless(length($tail)/2) { return 0; }

	for($i= 0; $i<length($tail)/2; $i++) {
		$sizeo +=  &sb_c2n(substr($tail,$i*2,2))+2;	}

	return $sizeo;
}

sub sb_isnumDB { my ($filename)= @_;
	my ($tnum,$header);

	&sb_existDB($filename);

	open(adb,"$filename");
	binmode adb;
	sysread(adb,$header,$slen);
	seek(adb,2,1);
	sysread(adb,$tnum,2);
	close (adb);

	if($header ne $sheader) { return 0; }
	return &sb_c2n($tnum);
}

sub sb_isDB { my ($filename)= @_;
	my ($temp,);

	open(adb,"$filename") || return 0;
	binmode adb;
	sysread(adb,$temp,$slen);
	close (adb);

	if($sheader eq $temp) { return 1; }
	return 0;
}

sub sb_existDB { my ($filename)= @_;
	my $num= pack "I", 0;

	if(-e $filename) { return 0; }

	open(edb,">$filename") || return 0;
	binmode edb;
	syswrite(edb,$sheader,$slen);
	syswrite(edb,&sb_n2c($maxDB),2);
	syswrite(edb,$num,2);
	syswrite(edb,("\xff" x ($maxDB*2)),$maxDB*2);
	close (edb);

	@flist= ("$filename");
	chmod(0777, @flist);

	return 1;
}

sub sb_lockDB { my ($file)= @_;
	my ($EndTime)= time+20;
	my ($lockfile)= "$file.lok";

	while((-e $lockfile) && (time < $EndTime)) { sleep(1); }
	open(lock2,">$lockfile");
	close(lock2);
}

sub sb_unlockDB { my ($file)= @_;
	my($lockfile)= "$file.lok";

	if(-e $lockfile) { unlink($lockfile); }
}

sub sb_pushDB { my ($filename)= @_;
	my ($tnum,$tail,$smaxDB,$offset)= 0;
	my ($buf,$pos)= 0;

#	&sb_lockDB($filename);
	open(pdb,"$filename") || return 0;
	binmode pdb;
	seek(pdb,$slen,0);
	read(pdb,$smaxDB,2);
	read(pdb,$tnum,2);
	$smaxDB= &sb_c2n($smaxDB);
	read(pdb,$tail,$smaxDB*2);

	$size= (-s $filename)-tell(pdb);
	read(pdb,$buf,$size);
	close (pdb);

	open(pdb,">$filename") || return 0;
	binmode pdb;
	syswrite(pdb,$sheader,$slen);
	syswrite(pdb,&sb_n2c($smaxDB+$maxDB),2);
	syswrite(pdb,$tnum,2);
	syswrite(pdb,$tail,$smaxDB*2);
	syswrite(pdb,("\xff" x ($maxDB*2)),$maxDB*2);

	syswrite(pdb,$buf,$size);
	close(pdb);
#	&sb_unlockDB($filename);
	return 1;
}

_superboard_database_endcode;
